import 'dart:convert';
import 'dart:math';
import 'dart:ui';

import 'package:flutter/cupertino.dart';
import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import 'package:flutter/rendering.dart';
import 'package:flutter/services.dart';
import 'package:insuideindoor/Constant.dart';
import 'package:insuideindoor/itemInfoView.dart';
import 'package:mapbox_gl/mapbox_gl.dart';
import 'package:sliding_up_panel/sliding_up_panel.dart';
import 'package:http/http.dart' as http;
import 'MarkerList.dart';
import 'package:flutter_svg/flutter_svg.dart';

export 'package:insuideindoor/main.dart' hide SlidingUpPanelExample;

import 'itemLocationMap.dart';
import 'iteminfo.dart';
import 'response/poi_response.dart';
import 'package:quds_popup_menu/quds_popup_menu.dart';

void main() => runApp(SlidingUpPanelExample());

class SlidingUpPanelExample extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    SystemChrome.setSystemUIOverlayStyle(SystemUiOverlayStyle(
      systemNavigationBarColor: Colors.grey[200],
      systemNavigationBarIconBrightness: Brightness.dark,
      systemNavigationBarDividerColor: Colors.black,
    ));

    return MaterialApp(
      debugShowCheckedModeBanner: false,
      title: 'SlidingUpPanel Example',
      theme: ThemeData(
        primarySwatch: Colors.blue,
      ),
      home: InsuideMapHomePage(),
    );
  }
}

class InsuideMapHomePage extends StatefulWidget {
  @override
  _InsuideMapHomePageState createState() => _InsuideMapHomePageState();
}

class _InsuideMapHomePageState extends State<InsuideMapHomePage> {
  final double _initFabHeight = 360.0;
  double _fabHeight = 50;
  double _panelHeightOpen = 0;
  double _panelHeightClosed = 380.0;
  String bannerUrl = "";
  String titleName = "";
  String description = "";
  String terminal = "";
  String imgIconPanel = "";
  List<PoiDataResponse> poiResponse = [];

  bool isMapRead = false;
  List<MapMarker> mapMarkerList = [];
  List<MapMarker> newList = [];
  List<MapMarker> filterListClick = [];
  late MapboxMapController mapController;
  bool isFilteredListVisible = false;
  bool isSearchNavIcon = false;
  String hintText = "Search Mumbai AirPort";
  String MAP_STYLE_URL =
      'mapbox://styles/merrillgonsalves/cjj3vgf313r5q2ss9qflyyz0i';
  Color textColor = Colors.red;
  bool pressedClickMez = true;
  bool pressedClickArri = true;
  bool pressedClickDep = true;

  String? getImag(String Subcategory, String Category) {
    String? imageS;

    if (Category == "utilities") {
      if (Subcategory == "escalator") {
        imageS = "assets/image/poi_escalator.png";
      } else if (Subcategory == "lift") {
        imageS = "assets/image/poi_lift.png";
      } else if (Subcategory == "staircase") {
        imageS = "assets/image/poi_stairs.png";
      } else if (Subcategory == "drinking water") {
        imageS = "assets/image/poi_water.png";
      } else if (Subcategory == "toilet") {
        imageS = "assets/image/poi_toilet_new_new.png";
      } else if (Subcategory == "prayer room") {
        imageS = "assets/image/poi_prayer_room.png";
      } else if (Subcategory == "smoking room") {
        imageS = "assets/image/poi_smoking.png";
      } else if (Subcategory == "baby changing room") {
        imageS = "assets/image/poi_baby.png";
      } else if (Subcategory == "service desk") {
        imageS = "assets/image/poi_info_helpdesk.png";
      } else if (Subcategory == "help desk") {
        imageS = "assets/image/poi_info_helpdesk.png";
      } else if (Subcategory == "fids") {
        imageS = "assets/image/poi_fids.png";
      } else if (Subcategory == "customs") {
        imageS = "assets/image/poi_customs.png";
      } else if (Subcategory == "baggage claim") {
        imageS = "assets/image/poi_baggage.png";
      } else if (Subcategory == "passport control") {
        imageS = "assets/image/poi_passport.png";
      } else if (Subcategory == "security screening") {
        imageS = "assets/image/poi_security.png";
      } else if (Subcategory == "check-in counters") {
        imageS = "assets/image/poi_check_in.png";
      } else if (Subcategory == "gates") {
        imageS = "assets/image/poi_gate";
      } else if (Subcategory == "transit") {
        imageS = "assets/image/poi_transit.png";
      } else if (Subcategory == "lost and found") {
        imageS = "assets/image/poi_lost_found.png";
      } else if (Subcategory == "charging") {
        imageS = "assets/image/poi_power.png";
      } else if (Subcategory == "exit") {
        imageS = "assets/image/poi_exit.png";
      } else if (Subcategory == "seating") {
        imageS = "assets/image/poi_seating.png";
      } else if (Subcategory == "bus") {
        imageS = "assets/image/poi_bus.png";
      } else if (Subcategory == "car") {
        imageS = "assets/image/poi_car.png";
      } else if (Subcategory == "metro") {
        imageS = "assets/image/poi_metro.png";
      } else if (Subcategory == "train") {
        imageS = "assets/image/poi_train";
      } else if (Subcategory == "medical") {
        imageS = "assets/image/poi_medical.png";
      } else if (Subcategory == "disabled toilet") {
        imageS = "assets/image/poi_disabled_toilet.png";
      } else if (Subcategory == "male toilet") {
        imageS = "assets/image/poi_male_toilet.png";
      } else if (Subcategory == "female toilet") {
        imageS = "assets/image/poi_female_toilet.png";
      }
    } else if (Category == "services") {
      imageS = "assets/image/poi_lounge.png";

      if (Subcategory == "lounge") {
        imageS = "assets/image/poi_lounge.png";
      } else if (Subcategory == "currency exchange") {
        imageS = "assets/image/poi_exchange_new.png";
      } else if (Subcategory == "ticket counter") {
        imageS = "assets/image/poi_ticket.png";
      } else if (Subcategory == "children's play area") {
        imageS = "assets/image/poi_play.png";
      } else if (Subcategory == "atm") {
        imageS = "assets/image/poi_atm.png";
      } else if (Subcategory == "post office") {
        imageS = "assets/image/poi_post_office.png";
      } else if (Subcategory == "telephone") {
        imageS = "assets/image/poi_phone.png";
      } else if (Subcategory == "tourism") {
        imageS = "assets/image/poi_tourism.png";
      }
    } else if (Category == "food & drink") {
      imageS = "assets/image/poi_food_new.png";
    } else if (Category == "shopping") {
      imageS = "assets/image/poi_shopping_new.png";
    }

    return imageS;
  }

  @override
  void initState() {
    super.initState();
    //callApi();
    _fabHeight = _initFabHeight;
  }

  @override
  Widget build(BuildContext context) {
    _panelHeightOpen = MediaQuery.of(context).size.height * .99;
    return Material(
      child: Stack(
        alignment: Alignment.topCenter,
        children: <Widget>[
          SlidingUpPanel(
            maxHeight: _panelHeightOpen,
            minHeight: _panelHeightClosed,
            parallaxEnabled: true,
            parallaxOffset: .5,
            body: _body(),
            panelBuilder: (sc) => _panel(sc),
            borderRadius: BorderRadius.only(
                topLeft: Radius.circular(20.0),
                topRight: Radius.circular(20.0)),
            onPanelSlide: (double pos) => setState(() {
              // _fabHeight = pos * (_panelHeightOpen - _panelHeightClosed) +
              //     _initFabHeight;
              _panelHeightClosed;
            }),
          ),

          Positioned(
            right: 25.0,
            bottom: 400,
            child: Container(
                height: 80,
                width: 50,
                decoration: BoxDecoration(
                    color: Colors.white,
                    borderRadius: BorderRadius.all(Radius.circular(12.0))),
                child: Column(
                  mainAxisAlignment: MainAxisAlignment.center,
                  children: <Widget>[
                    // IconButton(
                    //   icon: Image.asset("assets/image/floor.png"),
                    //   onPressed: () {},
                    //   iconSize: 10,
                    // ),
                    // Divider(
                    //   color: Colors.black,
                    //   height: 1,
                    // ),
                    // IconButton(
                    //   icon: Image.asset("assets/image/floor.png"),
                    //   onPressed: () {
                    //
                    //   },
                    //   iconSize: 10,
                    // ),
                    // Divider(
                    //   color: Colors.black,
                    //   height: 1,
                    // ),
                    SizedBox(
                      height: 5,
                    ),
                    QudsPopupButton(
                        // backgroundColor: Colors.red,
                        items: getMenuItems(),
                        child: Image.asset("assets/image/floor.png")),

                    SizedBox(
                      height: 5,
                    ),
                  ],
                )),
          ),

          // the fab

          Positioned(
              top: 0,
              child: ClipRRect(
                  child: BackdropFilter(
                      filter: ImageFilter.blur(sigmaX: 10, sigmaY: 10),
                      child: Container(
                        width: MediaQuery.of(context).size.width,
                        height: MediaQuery.of(context).padding.top,
                        color: Colors.transparent,
                      )))),

          //the SlidingUpPanel Title
        ],
      ),
    );
  }

  List<QudsPopupMenuBase> getMenuItems() {
    // Default color

    return [
      QudsPopupMenuItem(
          title: Text('Mezzanine Floor',
              style: pressedClickMez
                  ? TextStyle(color: Colors.black)
                  : TextStyle(color: Colors.redAccent)),
          onPressed: () {
            setState(() {
              MAP_STYLE_URL =
                  'mapbox://styles/merrillgonsalves/cjj3vgf313r5q2ss9qflyyz0i';
              pressedClickMez = !pressedClickMez;
              pressedClickArri = true;
              pressedClickDep = true;
            });
          }),
      QudsPopupMenuItem(
          title: Text('Arrivals Floor',
              style: pressedClickArri
                  ? TextStyle(color: Colors.black)
                  : TextStyle(color: Colors.redAccent)),
          onPressed: () {
            setState(() {
              MAP_STYLE_URL =
                  'mapbox://styles/merrillgonsalves/cjqs4ad4s5qhf2ro6bayaudh0';
              pressedClickArri = !pressedClickArri;
              pressedClickMez = true;
              pressedClickDep = true;
            });
          }),
      QudsPopupMenuItem(
          title: Text('Departures Floor',
              style: pressedClickDep
                  ? TextStyle(color: Colors.black)
                  : TextStyle(color: Colors.redAccent)),
          onPressed: () {
            setState(() {
              MAP_STYLE_URL =
                  'mapbox://styles/merrillgonsalves/cjnuc2nec4fng2rpe8xkkfa3o';
              pressedClickDep = !pressedClickDep;
              pressedClickMez = true;
              pressedClickArri = true;
            });
          })
    ];
  }

  Widget makeDismissable({required Widget child}) => GestureDetector(
        behavior: HitTestBehavior.opaque,
        onTap: () => Navigator.of(context).pop(),
        child: GestureDetector(
          onTap: () {},
          child: child,
        ),
      );

  void bottomSheet(context, MapMarker mapMarker) {
    showModalBottomSheet(
        context: context,
        isScrollControlled: true,
        backgroundColor: Colors.transparent,
        builder: (context) => makeDismissable(
              child: DraggableScrollableSheet(
                initialChildSize: 0.5,
                minChildSize: 0.5,
                maxChildSize: 1,
                builder: (_, scrollController) => Container(
                    decoration: BoxDecoration(
                        color: Colors.white,
                        borderRadius:
                            BorderRadius.vertical(top: Radius.circular(20))),
                    padding: EdgeInsets.all(16),
                    child: ListView(controller: scrollController, children: [
                      ListTile(
                        leading: Image.asset(
                          imgIconPanel,
                          height: 55,
                          width: 55,
                        ),
                        title: Text(titleName,
                            style: TextStyle(
                                fontSize: 22, fontStyle: FontStyle.normal)),
                        subtitle: Text(
                          "Security Hold Area . 1km away" +
                              "\n" +
                              "Terminal " +
                              terminal,
                          style: TextStyle(
                              fontSize: 14,
                              color: Color.fromRGBO(51, 51, 51, 1)),
                        ),
                      ),
                      SizedBox(
                        height: 10,
                      ),
                      Directionality(
                          textDirection: TextDirection.rtl,
                          child: Container(
                            height: 50,
                            child: ElevatedButton.icon(
                              onPressed: () {
                                _navigateToNextScreenMap(context, mapMarker);
                                print("You pressed Icon Elevated Button");
                              },
                              //icon data for elevated button
                              label: Text(
                                "Get Directions",
                                style: TextStyle(
                                    color: Color.fromRGBO(34, 34, 34, 1),
                                    fontSize: 18),
                              ),

                              icon: Image.asset(
                                  "assets/image/navigation_icon.png"),
                              //label text
                              style: ElevatedButton.styleFrom(
                                primary: Colors.white,
                                shape: RoundedRectangleBorder(
                                    borderRadius: BorderRadius.circular(25),
                                    side: BorderSide(
                                        color: Color.fromRGBO(34, 34, 34, 1))),
                              ),
                            ),
                          )),
                      SizedBox(
                        height: 20.0,
                      ),
                      Card(
                        semanticContainer: true,
                        clipBehavior: Clip.antiAliasWithSaveLayer,
                        child: Image.network(
                          bannerUrl,
                          width: 374,
                          height: 250,
                          fit: BoxFit.cover,
                        ),
                        shape: RoundedRectangleBorder(
                          borderRadius: BorderRadius.circular(10.0),
                        ),
                      ),
                      SizedBox(
                        height: 10.0,
                      ),
                      Padding(
                          padding:
                              const EdgeInsets.only(right: 14.0, left: 14.0),
                          child: Text(
                            description,
                            style: TextStyle(
                                color: Color.fromRGBO(34, 34, 34, 1),
                                fontSize: 16),
                          )),
                      SizedBox(
                        height: 25.0,
                      ),
                      Padding(
                        padding: const EdgeInsets.only(left: 15, right: 10),
                        child: Column(
                          crossAxisAlignment: CrossAxisAlignment.start,
                          children: <Widget>[
                            Align(
                              alignment: Alignment.centerLeft,
                              child: Text(
                                "Information",
                                style: TextStyle(
                                    fontSize: 16,
                                    color: Color.fromRGBO(102, 102, 102, 1),
                                    fontStyle: FontStyle.italic),
                              ),
                            )
                          ],
                        ),
                      ),
                      SizedBox(
                        height: 20,
                      ),
                      ListTile(
                        leading: Image.asset(
                          "assets/image/call.png",
                          height: 40,
                          width: 30,
                        ),
                        title: Text("087464664",
                            style: TextStyle(
                                fontSize: 18, fontStyle: FontStyle.normal)),
                      ),
                      ListTile(
                        leading: Image.asset(
                          "assets/image/clock.png",
                          height: 40,
                          width: 30,
                        ),
                        title: Text("087464664",
                            style: TextStyle(
                                fontSize: 18, fontStyle: FontStyle.normal)),
                      )
                    ])),
              ),
            ));
  }

  Widget _panel(ScrollController sc) {
    return MediaQuery.removePadding(
        context: context,
        removeTop: true,
        child: ListView(
          controller: sc,
          children: <Widget>[
            SizedBox(
              height: 12.0,
            ),
            Row(
              mainAxisAlignment: MainAxisAlignment.center,
              children: <Widget>[
                Container(
                  width: 47,
                  height: 5,
                  decoration: BoxDecoration(
                      color: Colors.grey[300],
                      borderRadius: BorderRadius.all(Radius.circular(12.0))),
                ),
              ],
            ),
            const SizedBox(
              height: 18.0,
            ),
            Padding(
                padding: const EdgeInsets.only(right: 10.0, left: 10.0),
                child: TextField(
                  decoration: InputDecoration(
                      border: OutlineInputBorder(
                          borderRadius: BorderRadius.circular(25.0),
                          borderSide: BorderSide.none),
                      hintStyle:
                          TextStyle(color: Color.fromRGBO(51, 51, 51, 1)),
                      hintText: hintText,
                      filled: true,
                      enabled: false,
                      prefixIcon: Image.asset("assets/image/search_ic.png"),
                      suffixIcon: isSearchNavIcon
                          ? IconButtonCancelView()
                          : IconButtonNavView(),
                      fillColor: Color.fromRGBO(234, 235, 237, 1)),
                  onTap: () {
                    _navigateToNextScreen(context, true);
                  },
                )),
            SizedBox(
              height: 10.0,
            ),
            expolreView(),
            SizedBox(
              height: 20,
            ),
            Visibility(visible: isFilteredListVisible, child: lisViewFiler()),
          ],
        ));
  }

  Widget IconButtonNavView() {
    return (IconButton(
      icon: Image.asset("assets/image/search_nav.png"),
      iconSize: 20,
      onPressed: () {
        _navigateToNextScreen(context, false);
        // setState(() {
        //   mapController.removeSymbols(mapController.symbols);
        //   setSymbolicMarker();
        //   isFilteredListVisible = false;
        // });
      },
    ));
  }

  Widget IconButtonCancelView() {
    return IconButton(
      icon: Icon(Icons.close),
      onPressed: () {
        setState(() {
          mapController.removeSymbols(mapController.symbols);
          setSymbolicMarker();
          isFilteredListVisible = false;
          isSearchNavIcon = false;
          hintText = "Search Mumbai Airport";
        });
      },
    );
  }

  Widget expolreView() {
    return Visibility(
        visible: !isFilteredListVisible,
        child: Column(

          children: [
            SizedBox(
              height: 10,
            ),
            Align(
                alignment: Alignment.centerLeft,
                child: Padding(
                  padding: EdgeInsets.only(left: 20),
                  child: Text("Explore",
                      textAlign: TextAlign.left,
                      style: TextStyle(
                          fontSize: 18,
                          fontStyle: FontStyle.italic,
                          color: Color.fromRGBO(102, 102, 102, 1))),
                )),
            SizedBox(
              height: 10.0,
            ),
            Padding(
              padding: EdgeInsets.only(left: 20),
              child: Row(
                children: <Widget>[
                  Expanded(
                      flex: 1,
                      child: _button(
                          "Restaurants",
                          "assets/image/restaurant_s.svg",
                          Color.fromRGBO(245, 183, 66, 1),
                          "Food & Drink")),
                  Expanded(
                      flex: 1,
                      child: _button("Shopping", "assets/image/shopping_s.svg",
                          Color.fromRGBO(229, 109, 214, 1), "Shopping")),
                ],
              ),
            ),
            SizedBox(
              height: 20.0,
            ),
            Padding(
              padding: EdgeInsets.only(left: 20),
              child: Row(
                children: <Widget>[
                  Expanded(
                      flex: 1,
                      child: _button(
                          "Facilities",
                          "assets/image/facility_s.svg",
                          Color.fromRGBO(255, 109, 110, 1),
                          "Services")),
                  Expanded(
                      flex: 1,
                      child: _button(
                          "Utilities",
                          "assets/image/restaurant_s.svg",
                          Color.fromRGBO(164, 114, 73, 1),
                          "Utilities")),
                ],
              ),
            ),
            SizedBox(
              height: 10.0,
            ),
            Container(
              margin: const EdgeInsets.all(15.0),
              padding: const EdgeInsets.all(15.0),
              height: 90,
              decoration: BoxDecoration(
                  border: Border.all(color: Color.fromRGBO(226, 226, 226, 1)),
                  borderRadius: BorderRadius.all(Radius.circular(5))),
              child: Column(
                children: [
                  Row(
                    children: [
                      Image.asset(
                        'assets/image/flight.png',
                        width: 25,
                        height: 25,
                      ),
                      SizedBox(
                        width: 10,
                      ),
                      Text(
                        'Boarding Starts',
                        style: TextStyle(
                            fontSize: 16, color: Color.fromRGBO(34, 34, 34, 1)),
                      ),
                    ],
                  ),
                  SizedBox(
                    height: 5.0,
                  ),
                  Row(
                    mainAxisAlignment: MainAxisAlignment.center,
                    children: [
                      Text(
                        '04.00',
                        style: TextStyle(fontSize: 16),
                      ),
                      Container(
                        width: 4.0,
                        height: 4.0,
                        margin: const EdgeInsets.only(right: 5.0, left: 5.0),
                        padding: const EdgeInsets.all(12.0),
                        decoration: BoxDecoration(
                            color: Color.fromRGBO(102, 102, 102, 1),
                            shape: BoxShape.circle,
                            boxShadow: [
                              BoxShadow(
                                color: Color.fromRGBO(0, 0, 0, 0.15),
                                blurRadius: 6.0,
                              )
                            ]),
                      ),
                      Text(
                        'Gate no D 47',
                        style: TextStyle(
                            fontSize: 16, color: Color.fromRGBO(34, 34, 34, 1)),
                      ),
                      Container(
                        width: 4.0,
                        height: 4.0,
                        margin: const EdgeInsets.only(right: 5.0, left: 5.0),
                        padding: const EdgeInsets.all(12.0),
                        decoration: BoxDecoration(
                            color: Color.fromRGBO(102, 102, 102, 1),
                            shape: BoxShape.circle,
                            boxShadow: [
                              BoxShadow(
                                color: Color.fromRGBO(0, 0, 0, 0.15),
                                blurRadius: 6.0,
                              )
                            ]),
                      ),
                      Text(
                        '6E 0433',
                        style: TextStyle(
                            fontSize: 16, color: Color.fromRGBO(34, 34, 34, 1)),
                      ),
                    ],
                  ),
                ],
              ),
            ),
          ],
        ));
  }

  Widget lisViewFiler() {
    return Container(
        child: ListView.builder(
      scrollDirection: Axis.vertical,
      shrinkWrap: true,
      itemCount: newList.length,
      itemBuilder: (BuildContext context, int index) {
        return ListTile(
          leading: Image.asset(newList[index].img),
          title: Text(newList[index].title),
          subtitle: Text(newList[index].description),
          onTap: () {
            _navigateToItemInfoView(context, newList[index]);
          },
        );
      },
    ));
  }

  void _navigateToItemInfoView(BuildContext context, MapMarker mapMarker) {
    Navigator.of(context).push(MaterialPageRoute(
      builder: (context) => ItemInfo(
        mapMarker: mapMarker,
        mapMarkerList: mapMarkerList,
      ),
    ));
  }

  void _navigateToNextScreen(BuildContext context, bool isNavToo) {
    print(mapMarkerList.toString());
    Navigator.of(context).push(MaterialPageRoute(
      builder: (context) => SearchItemInfoScreen(
        mapMarkerList: mapMarkerList,
        isNavTooView: isNavToo,
      ),
    ));
  }

  void _navigateToNextScreenMap(BuildContext context, MapMarker mapMarker) {
    print(mapMarkerList.toString());
    Navigator.of(context).push(MaterialPageRoute(
      builder: (context) => ItemLocationMapScreen(
        mapMarker: mapMarker,
        mapMarkerList: mapMarkerList,
      ),
    ));
  }

  Future _initImages() async {
    // >> To get paths you need these 2 lines
    final manifestContent = await rootBundle.loadString('AssetManifest.json');

    final Map<String, dynamic> manifestMap = json.decode(manifestContent);
    // >> To get paths you need these 2 lines

    final imagePaths = manifestMap.keys
        .where((String key) => key.contains('image/'))
        .where((String key) => key.contains('.png'))
        .toList();

    setState(() {});
  }

  List<MapMarker> sortList(String s) {
    for (int i = 0; i < mapMarkerList.length; i++) {
      if (mapMarkerList[i].category == s) {
        newList.add(mapMarkerList[i]);
        print(mapMarkerList[i].category + mapMarkerList[i].title);
      }
    }

    return newList;
  }

  void filterMarkerList(String s) {
    mapController.removeSymbols(mapController.symbols);
    newList.clear();
    sortList(s);
    for (int i = 0; i < newList.length; i++) {
      print("newList" + newList[i].title);
      mapController.addSymbol(SymbolOptions(
        geometry:
            LatLng(newList[i].location.latitude, newList[i].location.longitude),
        iconSize: 02.1,
        textAnchor: "7",
        iconImage: newList[i].img,
      ));
    }
  }

  Widget _button(
      String label, String svgIcon, Color color, String categoryName) {
    return Row(
      children: <Widget>[
        GestureDetector(
          onTap: () {
            // filterMarkerList(categoryName);
            // hintText = categoryName;
            // setState(() {
            //   isFilteredListVisible = true;
            //   isSearchNavIcon = true;
            // });
          },
          child: Container(
            padding: const EdgeInsets.all(12.0),
            child: SvgPicture.asset(
              svgIcon,
              height: 18,
              width: 18,
              color: Colors.white,
            ),
            decoration:
                BoxDecoration(color: color, shape: BoxShape.circle, boxShadow: [
              BoxShadow(
                color: Color.fromRGBO(0, 0, 0, 0.15),
                blurRadius: 6.0,
              )
            ]),
          ),
        ),
        SizedBox(
          width: 12.0,
        ),
        Text(
          label,
          style: TextStyle(fontSize: 16),
        ),
      ],
    );
  }

  Widget _body() {
    // final showMarker = buildMarker();
    // final showFilterMarker = buildMarkerCategory();

    return MapboxMap(
      accessToken: Constant.MAP_ACCESS_TOKEN,
      initialCameraPosition: CameraPosition(
          target: LatLng(19.098977052761047, 72.87443855619064), zoom: 18),
      styleString: MAP_STYLE_URL,
      compassEnabled: false,
      onMapCreated: (MapboxMapController mapBoxController) {
        mapController = mapBoxController;
        isMapRead = true;
        print("mapcreated" + mapMarkerList.toString());
        // mapController.onSymbolTapped.add((argument) {
        //   _onSymbolTapped(argument);
        // });

        //19.098977052761047, 72.87443855619064
        //41.259555383140835, 28.741587357328253

        setState(() {
          mapController.animateCamera(
            CameraUpdate.newCameraPosition(
              const CameraPosition(
                bearing: 310.0,
                target: LatLng(19.098977052761047, 72.87443855619064),
                tilt: 60.0,
                zoom: 18.0,
              ),
            ),
          );

          // addGeojsonCluster(mapController);
        });
      },
    );
  }

  void callApi() async {
    String url = 'http://development.wisefly.in/poisroute/getnewpois';
    try {
      http.Response response = await http.post(Uri.parse(url),
          headers: {
            "Content-Type": "application/x-www-form-urlencoded",
          },
          encoding: Encoding.getByName('utf-8'),
          body: {
            'appname': "fff",
            'token': Constant.apiKey,
            'isPartner': "true"
          });
      var responseData = jsonDecode(response.body);
      var serverResponse = POI_Response.fromJson(responseData);

      if (response.statusCode == 200) {
        var position = 0;
        for (int i = 0; i < serverResponse.poidataresponseList.length; i++) {
          PoiDataResponse poiDataResponse =
              serverResponse.poidataresponseList[i];
          List<LocationsResponse> locationsList =
              poiDataResponse.locationResponseList;
          for (LocationsResponse location in locationsList) {
            position++;
            mapMarkerList.add(MapMarker(
                category: poiDataResponse.category,
                img: getImag(poiDataResponse.subcategory.toLowerCase(),
                        poiDataResponse.category.toLowerCase()) ??
                    "",
                title: poiDataResponse.poiMultilingual.en.name,
                location: LatLng(location.latitude, location.longitude),
                bannerUrl: location.banner_url,
                terminal: location.terminal,
                description: poiDataResponse.poiMultilingual.en.description,
                pos: position));
          }
        }

        // setState(() {
        //   mapController.animateCamera(
        //     CameraUpdate.newCameraPosition(
        //       const CameraPosition(
        //         bearing: 310.0,
        //         target: LatLng(41.25954828824802, 28.741141583911592),
        //         tilt: 60.0,
        //         zoom: 18.0,
        //       ),
        //     ),
        //   );
        //
        //    setSymbolicMarker();
        // });
      }
    } on Exception catch (e) {}
  }

  void setSymbolicMarker() {
    for (int i = 0; i < mapMarkerList.length; i++) {
      mapController.addSymbol(SymbolOptions(
        geometry: LatLng(mapMarkerList[i].location.latitude,
            mapMarkerList[i].location.longitude),
        iconSize: 02.1,
        textAnchor: "7",
        iconImage: mapMarkerList[i].img,
      ));
    }
    mapController.onSymbolTapped.add((argument) {
      _onSymbolTapped(argument);
    });
  }

  void _onSymbolTapped(Symbol symbol) {
    var pos = int.parse(symbol.id);

    if (isFilteredListVisible) {
      filterListClick.addAll(newList);
    } else {
      filterListClick.addAll(mapMarkerList);
    }

    print("symbolclick" +
        symbol.id +
        "symbol" +
        symbol.id +
        filterListClick[pos].title +
        filterListClick[pos].category);

    bannerUrl = filterListClick[pos].bannerUrl;
    titleName = filterListClick[pos].title;
    description = filterListClick[pos].description;
    terminal = filterListClick[pos].terminal;
    imgIconPanel = filterListClick[pos].img;
    bottomSheet(context, filterListClick[pos]);
  }

  void _onSymbolTappedFilterMarker(Symbol symbol) {
    var pos = int.parse(symbol.id);
    print("symbolclickFilter" +
        symbol.id +
        "symbol" +
        symbol.id +
        newList[pos].title);
    bannerUrl = newList[pos].bannerUrl;
    titleName = newList[pos].title;
    description = newList[pos].description;
    terminal = newList[pos].terminal;
    imgIconPanel = newList[pos].img;
    bottomSheet(context, newList[pos]);
  }

  static const places = {
    "type": "FeatureCollection",
    "features": [
      {
        "type": "Feature",
        "properties": {"icon": "assets/image/poi_shopping_new.png"},
        "geometry": {
          "type": "Point",
          "coordinates": [28.7420343430082, 41.25949516203111]
        }
      },
      {
        "type": "Feature",
        "properties": {"icon": "assets/image/poi_train.png"},
        "geometry": {
          "type": "Point",
          "coordinates": [28.741915316366857, 41.25967786707697]
        }
      },
      {
        "type": "Feature",
        "properties": {"icon": "assets/image/poi_ticket.png"},
        "geometry": {
          "type": "Point",
          "coordinates": [28.741587357328253, 41.259555383140835]
        }
      },
      {
        "type": "Feature",
        "properties": {"icon": "assets/image/poi_toilet_new.png"},
        "geometry": {
          "type": "Point",
          "coordinates": [28.74155440039763, 41.259557163177774]
        }
      },
      {
        "type": "Feature",
        "properties": {"icon": "assets/image/poi_toilet_new.png"},
        "geometry": {
          "type": "Point",
          "coordinates": [28.74152020223269, 41.25955665910358]
        }
      },
      {
        "type": "Feature",
        "properties": {"icon": "assets/image/poi_toilet_new.png"},
        "geometry": {
          "type": "Point",
          "coordinates": [28.741443759275764, 41.25955615502945]
        }
      },
      {
        "type": "Feature",
        "properties": {"icon": "assets/image/poi_toilet_new.png"},
        "geometry": {
          "type": "Point",
          "coordinates": [28.741412741069, 41.25955565095527]
        }
      },
      {
        "type": "Feature",
        "properties": {"icon": "assets/image/poi_toilet_new.png"},
        "geometry": {
          "type": "Point",
          "coordinates": [28.74133562755982, 41.2595551468813]
        }
      },
      {
        "type": "Feature",
        "properties": {"icon": "assets/image/poi_toilet_new.png"},
        "geometry": {
          "type": "Point",
          "coordinates": [28.741271925095717, 41.25955413873294]
        }
      },
      {
        "type": "Feature",
        "properties": {"icon": "assets/image/poi_toilet_new.png"},
        "geometry": {
          "type": "Point",
          "coordinates": [28.74137854290406, 41.25977542690782]
        }
      },
      {
        "type": "Feature",
        "properties": {"icon": "assets/image/poi_toilet_new.png"},
        "geometry": {
          "type": "Point",
          "coordinates": [28.74128332448403, 41.25976383324068]
        }
      },
      {
        "type": "Feature",
        "properties": {"icon": "assets/image/poi_toilet_new.png"},
        "geometry": {
          "type": "Point",
          "coordinates": [28.74109758150975, 41.259759800660184]
        }
      },
      {
        "type": "Feature",
        "properties": {"icon": "assets/image/poi_toilet_new.png"},
        "geometry": {
          "type": "Point",
          "coordinates": [28.74142790972393, 41.25963599709803]
        }
      },
      {
        "type": "Feature",
        "properties": {"icon": "assets/image/poi_train.png"},
        "geometry": {
          "type": "Point",
          "coordinates": [28.741145607225114, 41.25963196451007]
        }
      },
    ]
  };

  Future<void> addGeojsonCluster(MapboxMapController controller) async {
    await controller.addSource(
        "hazards",
        GeojsonSourceProperties(
            data: places,
            cluster: true,
            clusterMaxZoom: 14, // Max zoom to cluster points on
            clusterRadius:
                50 // Radius of each cluster when clustering points (defaults to 50)
            ));

    final featuresList = Data.fromJson(places);

    int size = featuresList.features?.length ?? 0;

    var layerPro;

    int count = 0;

    for (int i = 0; i < size; i++) {
      count++;
      // print(featuresList.features?[i].geometry?.coordinates);
      print(count);
      layerPro = SymbolLayerProperties(
          iconImage: [
            Expressions.caseExpression,
            [
              Expressions.boolean,
              [Expressions.has, 'point_count'],
              false
            ],
            featuresList.features?[i].properties?.icon,
            featuresList.features?[i].properties?.icon
          ],
          iconSize: 1.4,
          textField: featuresList.features?[i].geometry?.coordinates.toString(),
          textAllowOverlap: false,
          textAnchor: 'bottom',
          iconAnchor: 'top');
    }

    setState(() {
      //controller.addSymbolLayer("hazards", "hazards-layer", layerPro);
      controller.addLayer("hazards", "layerId1", layerPro);
    });

    //   await controller.addLayer(
    //       "hazards",
    //       "hazards-count",
    //       const SymbolLayerProperties(
    //         textField: 'Global Exchange',
    //         iconAnchor: 0.5,
    //         textAnchor: 0.8,
    //         textAllowOverlap: false,
    //         iconAllowOverlap: false,
    //       ));
    // }
  }
}

class Data {
  String? type;
  List<Features>? features;

  Data({this.type, this.features});

  Data.fromJson(Map<String, dynamic> json) {
    type = json['type'];
    if (json['features'] != null) {
      features = <Features>[];
      json['features'].forEach((v) {
        features!.add(new Features.fromJson(v));
      });
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['type'] = this.type;
    if (this.features != null) {
      data['features'] = this.features!.map((v) => v.toJson()).toList();
    }
    return data;
  }
}

class Features {
  String? type;
  Properties? properties;
  Geometry? geometry;

  Features({this.type, this.properties, this.geometry});

  Features.fromJson(Map<String, dynamic> json) {
    type = json['type'];
    properties = json['properties'] != null
        ? new Properties.fromJson(json['properties'])
        : null;
    geometry = json['geometry'] != null
        ? new Geometry.fromJson(json['geometry'])
        : null;
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['type'] = this.type;
    if (this.properties != null) {
      data['properties'] = this.properties!.toJson();
    }
    if (this.geometry != null) {
      data['geometry'] = this.geometry!.toJson();
    }
    return data;
  }
}

class Properties {
  String? icon;

  Properties({this.icon});

  Properties.fromJson(Map<String, dynamic> json) {
    icon = json['icon'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['icon'] = this.icon;
    return data;
  }
}

class Geometry {
  String? type;
  List<double>? coordinates;

  Geometry({this.type, this.coordinates});

  Geometry.fromJson(Map<String, dynamic> json) {
    type = json['type'];
    coordinates = json['coordinates'].cast<double>();
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['type'] = this.type;
    data['coordinates'] = this.coordinates;
    return data;
  }
}
